searchNodes=[{"doc":"Raspberry Pi 3 Model B / B+ This is the base Nerves System configuration for the Raspberry Pi 3 Model B.&lt;sup&gt;[Image credit](#fritzing)&lt;/sup&gt;FeatureDescriptionCPU1.2 GHz quad-core Cortex-A53 (ARMv8)Memory1 GB DRAMStorageMicroSDLinux kernel4.19 w/ Raspberry Pi patchesIEx terminalHDMI and USB keyboard (can be changed to UART)GPIO, I2C, SPIElixir CircuitsYes - ADCNoPWMYes, but no Elixir supportUARTttyAMA01 available - DisplayHDMI or 7&quot; RPi TouchscreenCameraYes - via rpi-userlandEthernetYesWiFiYes - Nerves.NetworkBluetoothHaraldWatch AudioHDMI/Stereo out","ref":"readme.html","title":"Raspberry Pi 3 Model B / B+","type":"extras"},{"doc":"The most common way of using this Nerves System is create a project with mix nerves.new and to export MIX_TARGET=rpi3. See the Getting started guide for more information.If you need custom modifications to this system for your device, clone this repository and update as described in Making custom systems","ref":"readme.html#using","title":"Raspberry Pi 3 Model B / B+ - Using","type":"extras"},{"doc":"The base image includes drivers for the onboard Raspberry Pi 3 wifi module (brcmfmac driver).","ref":"readme.html#supported-wifi-devices","title":"Raspberry Pi 3 Model B / B+ - Supported WiFi devices","type":"extras"},{"doc":"The Raspberry Pi has many options for audio output. This system supports the HDMI and stereo audio jack output. The Linux ALSA drivers are used for audio output.To try it out, run::os.cmd(&#39;espeak -ven+f5 -k5 -w /tmp/out.wav Hello&#39;) :os.cmd(&#39;aplay -q /tmp/out.wav&#39;)The general Raspberry Pi audio documentation mostly applies to Nerves. For example, to force audio out the HDMI port, run::os.cmd(&#39;amixer cset numid=3 2&#39;)Change the last argument to amixer to 1 to output to the stereo output jack.","ref":"readme.html#audio","title":"Raspberry Pi 3 Model B / B+ - Audio","type":"extras"},{"doc":"If you need better real-time performance from the Linux kernel, the preempt_rt patch set may help. Be aware that we do not test with the patches so this may not work. To enable it, make a custom system using this one as a base and add the following to the nerves_defconfig:BR2_LINUX_KERNEL_PATCH=&quot;http://cdn.kernel.org/pub/linux/kernel/projects/rt/4.19/patch-4.19.25-rt16.patch.xz&quot;Please verify the patch version since these instructions may be out-of-date.Next, update the Linux configuration to use it. Review the Nerves documentation for running make linux-menuconfig and enable PREEMPT_RT_FULL. Alternately, make the following change to the Linux configuration:-CONFIG_PREEMPT=y +CONFIG_PREEMPT_RT_FULL=yBuild the system and you should now have a preempt_rt kernel.","ref":"readme.html#linux-s-preempt_rt-patches","title":"Raspberry Pi 3 Model B / B+ - Linux's preempt_rt patches","type":"extras"},{"doc":"This system supports storing provisioning information in a small key-value store outside of any filesystem. Provisioning is an optional step and reasonable defaults are provided if this is missing.Provisioning information can be queried using the Nerves.Runtime KV store's Nerves.Runtime.KV.get/1 function.Keys used by this system are:KeyExample ValueDescriptionnerves_serial_number&quot;12345678&quot;By default, this string is used to create unique hostnames and Erlang node names. If unset, it defaults to part of the Raspberry Pi's device ID.The normal procedure would be to set these keys once in manufacturing or before deployment and then leave them alone.For example, to provision a serial number on a running device, run the following and reboot:iex&gt; cmd(&quot;fw_setenv nerves_serial_number 12345678&quot;)This system supports setting the serial number offline. To do this, set the NERVES_SERIAL_NUMBER environment variable when burning the firmware. If you're programming MicroSD cards using fwup, the commandline is:sudo NERVES_SERIAL_NUMBER=12345678 fwup path_to_firmware.fwSerial numbers are stored on the MicroSD card so if the MicroSD card is replaced, the serial number will need to be reprogrammed. The numbers are stored in a U-boot environment block. This is a special region that is separate from the application partition so reformatting the application partition will not lose the serial number or any other data stored in this block.Additional key value pairs can be provisioned by overriding the default provisioning.conf file location by setting the environment variable NERVES_PROVISIONING=/path/to/provisioning.conf. The default provisioning.conf will set the nerves_serial_number, if you override the location to this file, you will be responsible for setting this yourself.","ref":"readme.html#provisioning-devices","title":"Raspberry Pi 3 Model B / B+ - Provisioning devices","type":"extras"},{"doc":"There's a subtle coupling between the nerves_system_br version and the Linux kernel version used here. nerves_system_br provides the versions of rpi-userland and rpi-firmware that get installed. I prefer to match them to the Linux kernel to avoid any issues. Unfortunately, none of these are tagged by the Raspberry Pi Foundation so I either attempt to match what's in Raspbian or take versions of the repositories that have similar commit times.","ref":"readme.html#linux-kernel-and-rpi-firmware-userland","title":"Raspberry Pi 3 Model B / B+ - Linux kernel and RPi firmware/userland","type":"extras"},{"doc":"The Linux kernel compiled for Nerves is a stripped down version of the default Raspberry Pi Linux kernel. This is done to remove unnecessary features, select some Nerves-specific features, and to save space. To reproduce the kernel configuration found here, do the following (this is somewhat tedious):Start with arch/arm/configs/bcmrpi_defconfig. This is the kernel configuration used in the official Raspberry Pi images.Turn off all filesystems except for ext4, squashfs, tmpfs, proc, sysfs, and vfat. Squashfs only needs ZLIB support.vfat needs to default to utf8. Enable native language support for ascii, utf-8, ISO 8859-1, codepage 437, and codepage 850.Disable all network drivers and wireless LAN drivers except for Broadcom FullMAC WLAN.Disable PPP and SLIPDisable the WiFi drivers in the Staging drivers menusDisable TV, AM/FM, Media USB adapters, DVB Frontends and Remote controller support in the Multimedia support menus.Go to Device Drivers-&gt;Sound card support. Disable USB sound devices in ALSA. Disable Open Sound System.Go to Device Drivers-&gt;Graphics support. Disable DisplayLinkIn Kernel Features, select Preemptible Kernel (Low-Latency Desktop), disable the memory allocator for compressed pages.In Userspace binary formats, disable support for MISC binaries.In Networking support, disable Amateur Radio support, CAN bus subsystem, IrDA subsystem, Bluetooth, WiMAX, Plan 9, and NFC. (TBD - this may be too harsh, please open issues if you're using any of these and it's the only reason for you to create a custom system.)In Networking options, disable IPsec, SCTP, Asynchronous Transfer Mode, 802.1d Ethernet Bridging, L2TP, VLAN, Appletalk, 6LoWPAN, 802.15.4, DNS Resolver, B.A.T.M.A.N, Open vSwitch, MPLS, and the Packet Generator in Network testing.In Networking support-&gt;Wireless, enable &quot;use statically compiled regulatory rules database&quot;. Build in cfg80211 and mac80211. Turn off mac80211 mesh networking and LED triggers. Turn off cfg80211 wireless extensions compatibility.In Kernel hacking, disable KGDB, and Magic SysRq key.In Device Drivers, disable MTD support. In Block devices, disable everything but Loopback and RAM block device. Disable RAID and LVM.In Enable the block layer, deselect everything but the PC BIOS partition type (i.e., no Mac partition support, etc.).In Enable loadable module support, select &quot;Trim unused exported kernel symbols&quot;. NOTE: If you're having trouble with an out-of-tree kernel module build, try deslecting this!!In General Setup, turn off initramfs/initfd support, Kernel .config support, OProfile.In Device Drivers -&gt; I2C -&gt; Hardware Bus Support compile the module into the kernel and disable everything but BCM2708 BSC support.In Device Drivers -&gt; SPI compile in the BCM2835 SPI controller and User mode SPI device driver support.In Device Drivers -&gt; Staging disable Support for small TFT LCD modulesIn Device Drivers -&gt; Dallas's 1-wire support, disable everything but the GPIO 1-Wire master and the thermometer slave. (NOTE: Why is the thermometer compiled in? This seems historical.)Disable Hardware Monitoring support, Sonics Silicon Backplane supportIn Device Drivers -&gt; Character devices -&gt; Serial drivers, disable 8250 and SC16IS7xx support. Disable the RAW driver.In Networking support-&gt;Network options, disable IP: kernel level autoconfigurationIn Networking support-&gt;Network options-&gt;TCP: advanced congestion control disable everything except for CUBIC TCP.Disable Real Time Clock.Disable everything in Cryptographic API and Library routines that can be disabled. Sometimes you need to make multiple passes.Disable EEPROM 93CX6 support, PPS support, all GPIO expanders, Speakup core, Media staging drivers, STMicroelectronics STMPE, anything &quot;Wolfson&quot;.Disable most ALSA for SoC audio support and codecs. NOTE: We probably should support a few, but I have no clue which ones are most relevant and there are tons of device drivers in the list.Disable IIO and UIO.Disable NXP PCA9685 PWM driverImage credit: This image is from the Fritzing parts library.","ref":"readme.html#linux-kernel-configuration","title":"Raspberry Pi 3 Model B / B+ - Linux kernel configuration","type":"extras"}]